/*-----------------------------------------------------------------------------+
|                                                                              |
|  REXX source code listing for DrRexx application:                            |
|    D:\projects\odbc_installer\odbcinst.res                                   |
|                                                                              |
|  File last modified on: 07/08/01 at: 08:45pm                                 |
|  Listing produced on:   07/08/01 at: 08:46pm                                 |
|                                                                              |
+-----------------------------------------------------------------------------*/

SIGNAL ON SYNTAX
SIGNAL ON HALT
SIGNAL INIT

RETURN:
  SIGNAL VALUE DrRexxEvent()

L1:
  EXIT -1

L2:
  INTERPRET DrRexxInterpret()
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: main                                             |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: main (DIALOG) */
 
main_Timer:
  call main.msgbox.text ''
  call main.timer
  SIGNAL RETURN
 
main_Init:
  call main.installButton.disable 	/* turn off install button (until source is entered) */
  SIGNAL RETURN
 
/* Event handlers for: Help (PUSHBUTTON) */
 
main_Help_Click:
  'view odbcinst'
  SIGNAL RETURN
 
/* Event handlers for: showMessagesButton (PUSHBUTTON) */
 
main_showMessagesButton_Click:
  call showMessages
  SIGNAL RETURN
 
/* Event handlers for: sqlserver (PUSHBUTTON) */
 
main_sqlserver_Click:
  call main.close
  SIGNAL RETURN
 
/* Event handlers for: InstallButton (PUSHBUTTON) */
 
main_InstallButton_Click:
  call install
  SIGNAL RETURN
 
/* Event handlers for: notebook (NOTEBOOK) */
 
main_notebook_Init:
  parms.page1 = notebook.add(0,"F","SOURCE","Source","Specify source file or directory");
  parms.page2 = notebook.add(parms.page1,"N","DESTINATIONS","Destination","Specify where to install components");
  
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: Destinations                                     |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: Destinations (DIALOG) */
 
Destinations_Open:
  call main.msgbox.text ' '
  SIGNAL RETURN
 
Destinations_Init:
  call setupDestinationDialog
  
  SIGNAL RETURN
 
/* Event handlers for: createDirectories (PUSHBUTTON) */
 
Destinations_createDirectories_Click:
  call makeDirectories
  SIGNAL RETURN
 
Destinations_createDirectories_Init:
  call checkDirectories
  SIGNAL RETURN
 
/* Event handlers for: driversdest (ENTRYFIELD) */
 
Destinations_driversdest_Init:
  call checkDriversDest		/* done to set driversOK flag correctly */
  SIGNAL RETURN
 
Destinations_driversdest_LoseFocus:
  call driversdest.text stripSlash(driversDest.text())
  
  call checkDriversDest
  
  if (parms.driversOK = 0)  then do
  	call main.msgbox.text 'Invalid directory for ODBC drivers'
  end
  else call main.msgbox.text ''
  call checkInstallButton
  call checkDirectories
  SIGNAL RETURN
 
/* Event handlers for: dlldest (ENTRYFIELD) */
 
Destinations_dlldest_Init:
  call checkDllDest		/* done to set dllOK flag correctly */
  SIGNAL RETURN
 
Destinations_dlldest_LoseFocus:
  call dlldest.text stripSlash(dllDest.text())
  
  call checkDllDest
  if (parms.dllOK = 0)  then do
  	call main.msgbox.text 'Invalid directory for ODBC DLLs'
  end
  else call main.msgbox.text ''
  call checkInstallButton
  call checkDirectories
  SIGNAL RETURN
 
/* Event handlers for: exedest (ENTRYFIELD) */
 
Destinations_exedest_Init:
  call checkExeDest		/* done to set exeOK flag correctly */
  SIGNAL RETURN
 
Destinations_exedest_LoseFocus:
  call exedest.text stripSlash(exeDest.text())
  
  call checkExeDest
  if (parms.exeOK = 0)  then do
  	call main.msgbox.text 'Invalid directory for ODBC Executables'
  end
  else call main.msgbox.text ''
  call checkInstallButton
  call checkDirectories
  SIGNAL RETURN
 
/* Event handlers for: inidest (ENTRYFIELD) */
 
Destinations_inidest_Init:
  call checkIniDest	/* done to set iniOK flag correctly */
  SIGNAL RETURN
 
Destinations_inidest_LoseFocus:
  call inidest.text stripSlash(iniDest.text())
  
  call checkIniDest
  
  if (parms.iniOK = 0)  then do
  	call main.msgbox.text 'Invalid directory for ODBC INI Files'
  end
  else do
  	rc1 = sysfiletree(iniDest.text()||"\ODBCINST.INI",resultvar,'F')
  	if (resultvar.0 = 0) then do
  		parms.msgText5 = "Can't find ODBCINST.INI in "||iniDest.text()
  		call main.msgbox.text parms.msgText5
  		parms.msgtext5 = d2c(10)||d2c(13)||"---- Information: "||parms.msgText5
  	end
  	else do
  		parms.msgText5 = ""
  		 call main.msgbox.text ""
  	end
  
  	if (iniDest.text() \= sysbootdrive()||"\OS2") then do
  		parms.msgText6 = sysbootdrive()||"\OS2 is the standard location for the ODBCINST.INI file. You have entered a different location, which may cause problems with other ODBC install programs if you use them"
  		call showErrorBox "Warning", "ODBCPATH",parms.msgText6
  		parms.msgtext6 = d2c(10)||d2c(13)||"---- Warning: "||parms.msgText6
  	end
  	else  parms.msgText6 = ""
  
  end
  call checkInstallButton
  call checkDirectories
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: source                                           |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: inst_admin (CHECKBOX) */
 
source_inst_admin_Click:
  call checkInstallButton
  SIGNAL RETURN
 
/* Event handlers for: sourceBrowse (PUSHBUTTON) */
 
source_sourceBrowse_Click:
  filename = fileprompt("*.zip","Select Source")
  call source.sourceentry.text translate(filename)
  
  call checkSource
  SIGNAL RETURN
 
/* Event handlers for: sourceentry (ENTRYFIELD) */
 
source_sourceentry_LoseFocus:
  call source.sourceentry.text  stripSlash(source.sourceentry.text())
  call checkSource
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: DRIVERS                                          |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: DRIVERS (DIALOG) */
 
DRIVERS_Open:
  call main.msgbox.text ' '
  SIGNAL RETURN
 
DRIVERS_Init:
  if (drv_wat = 1) then do
      call driverList.add  "Watcom SQL 4","A","W"
  end
  
  if (drv_any = 1) then do
      call driverlist.add "SQL Anywhere","A","G"
  end
  SIGNAL RETURN
 
/* Event handlers for: DRIVERLIST (LISTBOX) */
 
DRIVERS_DRIVERLIST_Select:
  
  xx = drivers.driverlist.select()
  if (xx=0) then do
  	call main.notebook.item parms.pageX ,"S", "Select one or more drivers to install"
  	call checkInstallButton
  	signal return
  end
  cnt = 1
  
  do forever
  	xx = drivers.driverlist.select(xx,"N")
  	if (xx = 0) then do
  		call main.notebook.item parms.pageX ,"S", cnt||' selected'
  		leave
  	end
  	cnt = cnt + 1
  end
  
  call checkInstallButton
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: errorBox1                                        |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: Helpbutton2 (PUSHBUTTON) */
 
errorBox1_Helpbutton2_Click:
  say 'errorbox1.helpbutton  ' parms.tempHelpFile
  
  'view '||parms.tempHelpFile
  SIGNAL RETURN
 
/* Event handlers for: C1003 (PUSHBUTTON) */
 
errorBox1_C1003_Click:
  if (parms.errorFlag=999) then call main.close
  
  call errorBox1.close
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: installed                                        |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: deleteDriverButton (PUSHBUTTON) */
 
installed_deleteDriverButton_Click:
  call deleteDrivers
  SIGNAL RETURN
 
/* Event handlers for: installedDriverList (LISTBOX) */
 
installed_installedDriverList_Select:
  
  if (installed.installedDriverList.select()>0) then call installed.deleteDriverButton.enable
  else     call installed.deleteDriverButton.disable
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: overwritePrompt                                  |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: overwritePrompt (DIALOG) */
 
overwritePrompt_Init:
  parms.overSkip = 0
  parms.overReturn = 0
  call filename.text parms.opromptFilename
  call directory.text parms.opromptdir
  SIGNAL RETURN
 
/* Event handlers for: C1307 (PUSHBUTTON) */
 
overwritePrompt_C1307_Click:
  parms.overSkip = 2
  call overWritePrompt.close
  return 1
  SIGNAL RETURN
 
/* Event handlers for: C1306 (PUSHBUTTON) */
 
overwritePrompt_C1306_Click:
  call overwritePrompt.close
  return 1
  SIGNAL RETURN
 
/* Event handlers for: C1305 (PUSHBUTTON) */
 
overwritePrompt_C1305_Click:
  parms.overSkip = 1
  call overWritePrompt.close
  return 0
  SIGNAL RETURN
 
/* Event handlers for: overwrite (PUSHBUTTON) */
 
overwritePrompt_overwrite_Click:
  call overwritePrompt.close
  return 0
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: fatalErrorBox                                    |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: fatalErrorBox (DIALOG) */
 
fatalErrorBox_Init:
  call mesBox.text parms.errorMessage
  SIGNAL RETURN
 
/* Event handlers for: C1402 (PUSHBUTTON) */
 
fatalErrorBox_C1402_Click:
  call fatalErrorBox.close
  return 1
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Event handlers for dialog: installDone                                      |
|                                                                              |
+-----------------------------------------------------------------------------*/
 
/* Event handlers for: C1502 (PUSHBUTTON) */
 
installDone_C1502_Click:
  call installDone.close
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Global procedures:                                                          |
|                                                                              |
+-----------------------------------------------------------------------------*/

updateInstalledDriversList:
  procedure expose fileList. adminList. driverList. DrvSetup. sourceType ODBCAdm. ODBCDrv. parms.  ODBCReq. driverReqList.
  
  call installed.installedDriverList.delete
  
  installedList.0 = 0
  rc = sysini(parms.odbcinst,'ODBC Drivers','ALL:','installedList')
  /*  remove terminating null, if present and blanks if present */
  if (installedList.0>0) then do
  	do i=1 to installedList.0
  	installedList.i = strip(changestr('00'x,installedList.i,''))	
  end
  
  if (installedList.0>0) then do
  	do i=1 to installedList.0
  		call installed.installedDriverList.add installedList.i, "A"
  	end
  end
  RETURN

addToList:
  addToList: procedure expose adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList. fileList.
  arg pname fname
  
  if (parms.sourceType=2) then ipos = 67
  else                                   ipos = 37
  
  rc1 = sysfiletree(pname||fname,resultvar,'F')	
  
  if (resultvar.0 = 1) then do
  	i = fileList.0
  	i = i + 1
  	fileList.i = right(pname||fname,ipos+length(pname||fname))
  	fileList.0 = i
  end
  return

doUnpackFile:
  doUnpackFile: procedure  expose adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList.
  arg fname ddir
  
  	
  i = lastpos('\',fname)
  if (i>0) then xfname = substr(fname,i+1)
  else            xfname = fname
  
  xfname = changestr(".DL_",xfname,".DLL")
  xfname = changestr(".HL_",xfname,".HLP")
  xfname = changestr(".EX_",xfname,".EXE")
  xfname = changestr(".LI_",xfname,".LIC")
  
  if (parms.overSkip = 1) then do		/* overwrite all answered on previous prompt */
  
  	if (substr(parms.debug,3,1)='X')  then say 'unpackfile  ' fname '  ' ddir
  	'attrib -r ' ddir||"\"||xfname 		/* remove read only attributes, if they exist */
  	rc = sysfiledelete(ddir||"\"||xfname)	/* delete destination file, if it exists */
  	if (rc>2) then do
  		parms.errorMessage = ddir||"\"||xfname
  		signal errorStop8
  	end
  	'@unpack '||fname||" "||ddir
  	return
  end
  
  
  /* check for destination file existence */
  skip = 0	
  
  rc1 = sysfiletree(ddir||"\"||xfname,xList,'F')
  
  if (xList.0 = 1) then do		/* file already exists at destination with the same name */
  	if (parms.overSkip = 2) then return 	/* skip all */
  	parms.opromptFilename = fname
  	parms.opromptdir = ddir
  	skip = modalFor('overwritePrompt')
  end
  
  if (Skip=1) then return
  
  if (xList.0=1) then do
  	'attrib -r ' ddir||"\"||xfname 
  	rc = sysfiledelete(ddir||"\"||xfname)
  	if (rc\=0) then do
  		parms.errorMessage = ddir||"\"||xfname
  		signal errorStop8
  	end
  end
  if (substr(parms.debug,3,1)='X')  then say ' unpackfile  ' fname '  ' ddir
  
  '@unpack '||fname||" "||ddir
  
  return

doCopyFile:
  doCopyFile: procedure  expose  adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList.
  arg fname ddir
  
  
  if (parms.overSkip = 1) then do
  	if (substr(parms.debug,3,1)='X')  then say 'copyFile ' fname ' ' ddir
  	i = lastpos('\',fname)
  	if (i>0) then xfname = substr(fname,i+1)
  	else            xfname = fname
  	'attrib -r '||ddir||"\"||xfname		/* remove any read-only attributes this file name have */
  
  	rc = copyFile(fname,ddir)
  	if (rc \= 0) then do
  		parms.errorMessage = 'Error: '||copyEmes(rc)||" when trying to copy "||fname||" to "||ddir
  		rc = modalFor('fatalErrorBox')
  		call main.close
  		return
  	end
  	return
  end
  /* check for destination file existence */
  skip = 0	
  i = lastpos('\',fname)
  if (i>0) then xfname = substr(fname,i+1)
  else            xfname = fname
  
  rc1 = sysfiletree(ddir||"\"||xfname,xList,'F')
  if (xList.0 = 1) then do		/* file already exists at destination with the same name */
  	if (parms.overSkip = 2) then return 	/* skip all */
  	parms.opromptFilename = fname
  	parms.opromptdir = ddir
  	skip = modalFor('overwritePrompt')
  end
  
  if (skip=1) then return
  
  if (substr(parms.debug,3,1)='X')  then say 'copyFile ' fname ' ' ddir
  
  
  
  i = lastpos('\',fname)
  if (i>0) then xfname = substr(fname,i+1)
  else            xfname = fname
  
  
  'attrib -r '||ddir||"\"||xfname		/* remove any read-only attributes this file name have */
  rc = copyFile(fname,ddir)
  if (rc \= 0) then do
  	parms.errorMessage = 'Error: '||copyEmes(rc)||" when trying to copy "||fname||" to "||ddir
  	rc = modalFor('fatalErrorBox')
  	call main.close
  	return
  end
  
  return
  
  RETURN

doZipFile:
  doZipFile: procedure  expose  adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList.
  arg zfile fname ddir
  
  if (parms.overSkip = 1) then do
  
  	if (fname \= '-') then do
  		if (substr(parms.debug,3,1)='X')  then say ' unZip -jo ' zfile ' ' fname '  -d ' ddir
  		 '@unzip -jo '||zfile||" "||fname||"  -d "||ddir
  	end
  	else do
  		if (substr(parms.debug,3,1)='X')  then say ' unZip -jo ' zfile ' -d ' ddir
                         '@unzip -jo '||zfile||"  -d "||ddir
  	end
  	return
  end
  /* check for destination file existence */
  skip = 0		
  rc1 = sysfiletree(ddir||"\"||fname,xList,'F')
  if (xList.0 = 1) then do		/* file already exists at destination with the same name */
  	if (parms.overSkip = 2) then return 	/* skip all */
  	parms.opromptFilename = fname
  	parms.opromptdir = ddir
  	skip = modalFor('overwritePrompt')
  end
  
  if (Skip=1) then return
  
  
  if (fname \= '-') then do
  	if (substr(parms.debug,3,1)='X')  then say ' unZip -jo ' zfile ' ' fname '  -d ' ddir
  	 '@unzip -jo '||zfile||" "||fname||"  -d "||ddir
  end
  else do
  	if (substr(parms.debug,3,1)='X')  then say 'unZip -jo ' zfile ' -d ' ddir
  	'@unzip -jo '||zfile||"  -d "||ddir
  end
  
  return

install3:
  procedure expose  adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList.
  
  fname = sysbootdrive()||"\CONFIG.SYS"
  
  parms.odbcPath=destinations.inidest.text()
  parms.dllpath=destinations.dlldest.text()
  parms.driverspath=destinations.driversdest.text();
  parms.exepath=destinations.exedest.text()
  
  /* --- copy existing config.sys file to a new name - in case we screw up ----- */
  savedname = systempfilename(sysbootdrive()||"\CONFIG.???")
  if (savedname='') then signal errorStop6
  
  
  rc = copyFile(fname,savedname)
  if (rc\=0) then signal errorStop8
  
  
  newname = systempfilename(parms.temppath||"\ODBC????.SYS")
  if (newname='') then signal errorStop7
  
  /* ---- loop through new file and  ---- */
  
  lflag=0
  hflag = 0
  oflag = 0
  configFlag=0
  do while (lines(fname))
  
  	linex = strip(linein(fname))
  	parse value linex with tag ' ' name '=' nvalue
  
  	if (lflag=0) then do
          		if (translate(substr(tag,1,7))='LIBPATH') then do   /* LIBPATH processing */
            			lflag = 1
  		          lline = translate(linex)
            			parse value lline with tag '=' lvalue
  
            			/*   add current directory to libpath, for using different versions of Administrator */
  			if (substr(lvalue,1,2) \= '.;') then  do
  				configFlag=1
  				linex = changestr('=',linex,'=.;')
  				if (substr(parms.debug,6,1)='X') then say 'config.sys libpath get .;'
  			end
  
  			if (pos(parms.dllpath,lvalue)=0) then do 
  				linex=changestr('=.;',linex,'=.;'||parms.dllpath||';')
  				configFlag=1
  				if (substr(parms.debug,6,1)='X') then say 'config.sys libpath get dllpaths' parms.dllpath
  			end
  		           if (pos(parms.driverspath,lvalue)=0) & (parms.dllpath \= parms.driverspath) then do
  				linex=changestr('=.;',linex,'=.;'||parms.driverspath||';')
  				configFlag=1
  				if (substr(parms.debug,6,1)='X') then say 'config.sys libpath get driverspath' parms.driverspath
  			end
  		end
  	end
  
  	name = translate(name)
  
  	if (hflag=0) then do
  		if (name='HELP') then do
  			hflag = 1
  			lline = translate(nvalue)
  		             /*   add ODBC Drivers path to HELP variable */
  			if (pos(parms.driverspath,translate(lline))=0) then do
  				linex=changestr('=',linex,'='||parms.driverspath||';')
  				configFlag=1
  				if (substr(parms.debug,6,1)='X') then say 'config.sys help gets 'parms.driverspath
  			end
  		end
  	end
  
  	if (oflag = 0) then do
  		if (name = 'ODBC_PATH') then do
  			oflag = 1
  			if (translate(nvalue) \= parms.odbcPath) then do
  				linex = 'SET ODBC_PATH='||parms.odbcPath
  				configFlag=1
  				if (substr(parms.debug,6,1)='X') then say 'config.sys odbc_path gets set to' parms.odbcpath ' old='nvalue
  			end
  		end
  	end
  	
  	rc = lineout(newname,linex)
  
  end
  rc = lineout(newname)		/* close the file */
  rc = stream(fname,'C','CLOSE')
  
  rc = SysCreateObject("WPProgram", "ODBC Administrator", "<WP_CONFIG>","EXENAME="||parms.exepath||"\ODBCADM.EXE;ICONFILE="||parms.exepath||"\ODBCADM.ICO;OBJECTID=<ODBC_ADMIN>","F")
  rc = SysCreateObject("WPProgram", "ODBC Installer", "<WP_CONFIG>","EXENAME="||parms.exepath||"\ODBCINST.EXE;ICONFILE="||parms.exepath||"\ODBCINST.ICO;OBJECTID=<ODBC_ADMIN>","F")
  if (configFlag=1) then do
  	rc = copyFile(newname,fname)
  	if (rc\=0) then do
  		parms.errorMessage = 'Copy new config.sys ('||newname||')  back to ' fname ' error rc: ' copyEmes(rc)
  		signal errorStop9
  	end
  end
  
  call sysfiledelete newname
  
  msg1 = "Installation complete!"
  if (configFlag = 1) then msg1 = msg1||d2c(10)||d2c(13)||"Your CONFIG.SYS has been modified. You must reboot before using ODBC."
  if (source.inst_admin.select() = 1) then msg1 = msg1||d2c(10)||d2c(13)||"The ODBC Administrator is located in your System Setup folder - which is usually in your OS/2 System folder and is also usually accessing from the Desktop pop-up menu"
  
  
  call installDone.open
  call installDone.installDoneMsg.text msg1
  
  return

errorStops:
  
  errorStop2:
  parms.errorMessage =  "Could not open Driver list ("||parms.dlist||"). The file is either missing or has a syntax error. If the file exists try executing it from the command prompt ascertain the syntax error."
  rc = modalFor('fatalErrorBox') 
  call main.close
  return
  
  errorStop3:
  parms.errorMessage = "Could not open Driver Setup List ("||parms.slist||"). The file is either missing or has a syntax error. If the file exists try executing it from the command prompt ascertain the syntax error."
   rc = modalFor('fatalErrorBox') 
  call main.close
  return
  
  errorStop4:
  parms.errorMessage = "Error inserting the driver "||driverList.fnum.t||"into ODBCINST.INI"
   rc = modalFor('fatalErrorBox') 
  call main.close
  return
  
  errorStop5:
  parms.errorMessage = "Error inserting the settings for driver "||driverList.fnum.t||"into ODBCINST.INI"
   rc = modalFor('fatalErrorBox') 
  call main.close
  return
  
  
  errorStop6:
  parms.errorMessage = "Could create a new name to save your CONFIG.SYS file before editing it. If you have a large number of saved CONFIG.XXX files (where XXX = various characters) from other installs try deleting a few and re starting the ODBC Installer"
   rc = modalFor('fatalErrorBox') 
  call main.close
  return
  
  
  errorStop7:
  parms.errorMessage = "Could not create a new CONFIG.SYS file in "||parms.tempPath
   rc = modalFor('fatalErrorBox') 
  call main.close
  return
  
  errorStop8:
  parms.errorMessage = "Could not delete file "||parms.errorMessage
   rc = modalFor('fatalErrorBox') 
  call main.close
  return
  
  
  errorStop8:
  parms.errorMessage = "Could not save your CONFIG.SYS file before editing it. If you have a large number of saved CONFIG.XXX files (where XXX = various characters) from other installs try deleting a few and re starting the ODBC Installer"
   rc = modalFor('fatalErrorBox') 
  call main.close
  return
  
  
  errorStop9:
  /* parms.errorMessage = "Could not copy the newly created config.sys file back to where it belongs" */
   rc = modalFor('fatalErrorBox') 
  call main.close
  return

copyEmes:
  procedure expose adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList.
  arg ecode 
  
  select
      when ecode=0    then return "NO_ERROR" 
      when ecode=2    then return "ERROR_FILE_NOT_FOUND" 
      when ecode=3    then return "ERROR_PATH_NOT_FOUND" 
      when ecode=5    then return "ERROR_ACCESS_DENIED" 
      when ecode=26   then return "ERROR_NOT_DOS_DISK" 
      when ecode=32   then return "ERROR_SHARING_VIOLATION" 
      when ecode=36   then return "ERROR_SHARING_BUFFER_EXCEEDED" 
      when ecode=87   then return "ERROR_INVALID_PARAMETER" 
      when ecode=108  then return "ERROR_DRIVE_LOCKED" 
      when ecode=112  then return "ERROR_DISK_FULL" 
      when ecode=206  then return "ERROR_FILENAME_EXCED_RANGE" 
      when ecode=267  then return "ERROR_DIRECTORY" 
      when ecode=282  then return "ERROR_EAS_NOT_SUPPORTED" 
      when ecode=283  then return "ERROR_NEED_EAS_FOUND" 
      otherwise return 'Unknown error'
  end
  return 'Unknown error'

setupINI:
  procedure expose adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList. Drvsetup.
  arg inVal fnum
  
  
  /*   IF SETUP VALUE IS MISSING - OUTPUT AN ERROR MESSAGE */
  
  
  if (substr(parms.debug,5,1)='X') then do
  	say ' -- Setup for ' driverList.fnum.t ' --- (ODBCINST.INI) ----'
  	say 'add/change in [ODBC Drivers]'
  	say '   ' driverList.fnum.t  '  Installed'
  end
  rc = SysIni( parms.odbcinst, 'ODBC Drivers', driverList.fnum.t, 'Installed')
  
  if (rc='ERROR:') then signal errorStop4
  if (substr(parms.debug,5,1)='X') then do
  	say 'add/change in ['||driverList.fnum.t||']'
  end
  do i=1 to DrvSetup.inVal.0
  
  	/*  if the Setup title is specified but has no value, use the value of the driver (element 1) */
  	if (translate(DrvSetup.inVal.i.t) = 'SETUP') & (DrvSetup.inVal.i.v='') then do
  		xloc = changestr('/',driverList.fnum.1,'\')
  		if (pos('\',xloc)>0) then xloc = translate(substr(xloc,lastpos("\",xloc)+1))
  		call chgName
  		/*  check if driver name is actually a zip file name */
  		/* which happens when the "alternate" file is found for a driver */
  		/* put the real driver DLL name into the setup file - pull the real driver name */
  		/* from the ODBCDrv. variable */
  		if (substr(xloc,length(xloc)-2,3) = 'ZIP') then do
  			ee = driverList.fnum.q		/* get index back into ODBCDrv */
  			xloc = ODBCDrv.ee.1		/* get the first file listed in the section */
  		end
  		if (substr(parms.debug,5,1)='X') then say DrvSetup.inVal.i.t ' = ' Destinations.driversdest.text()||"\"||xloc
  		call  SysIni  parms.odbcinst, driverList.fnum.t, DrvSetup.inVal.i.t , Destinations.driversdest.text()||"\"||xloc||'0'x
  		iterate
  	end
  	if (translate(DrvSetup.inVal.i.t) = 'DRIVER') then do
  		/*   put the drivers destination path in front of the driver file name */
  		if (DrvSetup.inVal.i.v='') then do
  			xloc = changestr('/',driverList.fnum.1,'\')
  			if (pos('\',xloc)>0) then xloc = translate(substr(xloc,lastpos("\",xloc)+1))
  			/*  check if driver name is actually a zip file name */
  			/* which happens when the "alternate" file is found for a driver */
  			/* put the real driver DLL name into the setup file - pull the real driver name */
  			/* from the ODBCDrv. variable */
  			if (substr(xloc,length(xloc)-2,3) = 'ZIP') then do
  				ee = driverList.fnum.q		/* get index back into ODBCDrv */
  				xloc = ODBCDrv.ee.1		/* get the first file listed in the section */
  			end
  		end
  		else xloc = DrvSetup.inVal.i.v
  		call chgName
  
  		if (substr(parms.debug,5,1)='X') then say DrvSetup.inVal.i.t ' = ' Destinations.driversdest.text()||"\"||xloc
  		call  SysIni  parms.odbcinst, driverList.fnum.t, DrvSetup.inVal.i.t , Destinations.driversdest.text()||"\"||xloc||'0'x
  		iterate
  	end
  	if (translate(DrvSetup.inVal.i.t) = 'SETUP') then do
  		/*   put the drivers destination path in front of the setup file name */
  		xloc = DrvSetup.inVal.i.v
  		call chgName
  		if (substr(parms.debug,5,1)='X') then say DrvSetup.inVal.i.t ' = ' Destinations.driversdest.text()||"\"||xloc
  		call  SysIni  parms.odbcinst, driverList.fnum.t, DrvSetup.inVal.i.t , Destinations.driversdest.text()||"\"||xloc||'0'x
  		iterate
  	end
  
  	if (substr(parms.debug,5,1)='X') then say DrvSetup.inVal.i.t ' = ' DrvSetup.inVal.i.v
         call  SysIni  parms.odbcinst, driverList.fnum.t, DrvSetup.inVal.i.t , DrvSetup.inVal.i.v
         if (RESULT='ERROR:') then signal errorStop5
  end
  
  return
  
  chgName:
  xloc = translate(xloc)
  xloc = changestr(".DL_",xloc,".DLL")
  xloc   = changestr(".HL_",xloc,".HLP")
  xloc   = changestr(".EX_",xloc,".EXE")
  xloc   = changestr(".LI_",xloc,".LIC")
  RETURN

Install2:
  procedure expose adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList. reqLst.
  arg  tt
  
  /*  --- Check if any "required" files are specified */
  
  ww = words(driverList.tt.r)
  
  do xx = 1 to ww
  	wrd = word(driverList.tt.r,xx) 
  	if (reqLst.wrd = 'Y')  then iterate
  	else	call installReq wrd
  end
  
  return
  
  /* -------------- Install required files that have not already been installed this session ------- */
  
  installReq:  procedure expose adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList. reqLst.
  arg wrd
  
  if (substr(parms.debug,4,1)='X')  then say ' ---- Required files -----'
  
  do i = 1 to driverReqList.wrd.0
  
  	if (parms.sourceType = 1) then do		/* directory */
  		if (substr(driverReqList.wrd.i,length(driverReqList.wrd.i)-3,4) = '.ZIP') then do
  			call doZipFile driverReqList.wrd.i '-'  Destinations.driversdest.text()
  			iterate	
  		end
  		if (substr(driverReqList.wrd.i,length(driverReqList.wrd.i),1) = '_') then do
  			call doUnpackFile  driverReqList.wrd.i   Destinations.driversdest.text()
  			iterate	
  		end
  		call doCopyFile  driverReqList.wrd.i   Destinations.dlldest.text()
  	end
  	if (parms.sourceType=2) then do
  		if (substr(driverReqList.wrd.i,length(driverReqList.wrd.i)-3,4) = '.ZIP') then do
  			'@unzip -jo '||parms.fileEntry||" "||driverReqList.wrd.i||"  -d "||parms.tempPath	
  			tempStr = changeStr("/",driverReqList.wrd.i,"\")
  			xpos = lastpos("\",tempStr)
  			if (xpos>0) then tempStr = substr(tempStr,xpos+1)
  
  			call doZipFile  parms.tempPath||"\"||tempstr "-" Destinations.driversdest.text()
  			'attrib -r ' parms.tempPath||"\"||tempStr
  			call sysfiledelete parms.tempPath||"\"||tempStr
  			iterate
  		end
  		/*  If the required file (in the zipped source file) is a packed file */
  		if (substr(driverReqList.wrd.i,length(driverReqList.wrd.i),1) = '_') then do
  			'@unzip -jo '||parms.fileEntry||" "||driverReqList.wrd.i||"  -d "||parms.tempPath
  			tempStr = changeStr("/",driverReqList.wrd.i,"\")
  			xpos = lastpos("\",tempStr)
  			if (xpos>0) then tempStr = substr(tempStr,xpos+1)	
  			tempStr = strip(tempStr)	
  			call doUnpackFile  parms.tempPath||"\"||tempStr Destinations.driversdest.text()
  			'attrib -r ' parms.tempPath||"\"||tempStr
  			call sysfiledelete parms.tempPath||"\"||tempStr
  			iterate	
  		end
  		call doZipFile  parms.fileEntry driverReqList.wrd.i Destinations.driversdest.text()
  	end
  end
  
  reqLst.wrd = 'Y'
  
  return

deleteDrivers:
  procedure expose adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList.
  DsnList. = ''
  DSNList.0=0
  DsnDrvList. = ''
  DsnDrvList.0 = 0
  
  
  if (parms.odbc \= '') then do
  	rc = sysini(parms.odbc,"ODBC Data Sources","ALL:","DSNList")
  	if (DSNList.0 > 0) then do
  		do i = 1 to DSNList.0
  			DsnDrvList.i = strip(changestr('00'x,sysini(parms.odbc,"ODBC Data Sources",DSNList.i),''))
  		end
  		DsnDrvList.0 = i
  	end
  end
  
  /****
  do i=1 to DSNList.0
  	say 'DSN: ' DsnList.i  '   driver:' DsnDrvList.i
  end
  *****/
  
  i = installed.installedDriverList.select()
  
  msgText = ''
  
  do while (i > 0)
  	drtxt = installed.installedDriverList.item(i)
  
  	if (DsnDrvList.0>0) then do
  		do k=1 to DsnDrvList.0
  
  			if (DsnDrvList.k = drtxt) then do
  				/*   delete each dsn for this driver */
  				rc = sysini(parms.odbc,DsnList.k,'DELETE:')
  				if (rc \= '')  then msgText=msgText||d2c(10)||d2c(13)||"error deleting "||DsnList.k||" from ODBC"
  
  				rc = sysini(parms.odbc,"ODBC Data Sources",DsnList.k,'DELETE:')
  				if (rc \= '')  then msgText=msgText||d2c(10)||d2c(13)||"error deleting "||DsnList.k||" from Data Sources in ODBC"
  			end
  		end
  	end
  
  	rc = sysini(parms.odbcinst,"ODBC Drivers",drtxt,'DELETE:')
  	if (rc \= '')  then msgText=msgText||d2c(10)||d2c(13)||"error deleting "||drtxt||" from ODBC Drivers of ODBCINST"
  
  	rc = sysini(parms.odbcinst,drtxt,'DELETE:')
  	if (rc \= '')  then msgText=msgText||d2c(10)||d2c(13)||"error deleting "||drtxt||" from ODBCINST"
  
  	call installed.installedDriverList.delete(i)
  
  	i = installed.installedDriverList.select()
  end
  if (msgText \= '') then call showErrorBox "Information" ,"Error1", msgText
  
   call installed.deleteDriverButton.disable
  RETURN

checkDllDest:
  resultvar.0 = 0
  
  if (length(destinations.dlldest.text())>0) then do
  	call  sysfiletree destinations.dlldest.text(), resultvar, 'D'
  	if (resultvar.0 > 0) then parms.dllOK=1
  	else parms.dllOK=0
  end
  else parms.dllOK=0
  RETURN

showMessages:
  procedure expose fileList. adminList. driverList. DrvSetup. sourceType ODBCAdm. ODBCDrv. parms.  ODBCReq. driverReqList.
  
  if (parms.msgText1 \= '')|(parms.msgText2 \= '')|(parms.msgText3 \= '')|(parms.msgText4 \= '')|(parms.msgText5 \= '')|(parms.msgText5 \= '')|(parms.msgText6 \= '')|(parms.msgText7 \= '')   then do
  	i = 0
  	if (parms.msgtext1 \= '') then i = i+1
  	if (parms.msgtext2 \= '') then i = i+1
  	if (parms.msgtext3 \= '') then i = i+1
  	if (parms.msgtext4 \= '') then i = i+1
  	if (parms.msgtext5 \= '') then i = i+1
  	if (parms.msgtext6 \= '') then i = i+1
  	if (parms.msgtext7 \= '') then i = i+1
  	call showErrorBox "Information - "||i||" Messages" ,"Error1", parms.msgText1||parms.msgText2||parms.msgText3||parms.msgText4||parms.msgText5||parms.msgText6||parms.msgText7
  end
  RETURN

setupDestinationDialog:
  procedure expose fileList. adminList. driverList. DrvSetup. sourceType ODBCAdm. ODBCDrv. parms.  ODBCReq. driverReqList.
  
  call main.msgbox.text 'Searching for existing ODBC installation'
  
  parms.msgtext1 = ''
  parms.msgText2 = ''
  parms.msgText3 = ''
  parms.msgText4 = ''
  
  
  /* if the env variable ODBCPATH exists - set the INI Destination field to that value */
  /* otherwise set INI Dest field to C:\OS2 (assumming C is the boot driver) */
  if (length(parms.odbcpath)>0) then call inidest.text parms.odbcpath
  else call  inidest.text sysbootdrive()||"\OS2"
  
  /* --- Search the odbcPath for ODBCINST.INI file --- */
  if (length(parms.odbcPath)>0) then do
  	xx = rxSearchPath("ODBCINST.INI","ODBC_PATH","V")
  	parse value xx with i tempStr
  	if (i=0) then do					/* found ODBCINST.INI somewhere in ODBC_PATH */
  		parms.odbcinst = translate(tempStr);	/* save the fully qualified path/filename of ODBCINST.INI */
  	        	tempStr = translate(substr(tempStr,1,length(tempStr)-13)) /* split off path from path/filename */
  		rc1 = sysfiletree(tempStr"\ODBC.INI",resultvar,'F')	/* check for the existence of ODBC.INI */
  		if (resultvar.0 = 1) then parms.odbc = tempStr||"\ODBC.INI"	/* found it, save path/filename  */
  	        	if (parms.odbcPath \= tempStr) then do   		/* compare derived path of location of ODBCINST.INI with ODBC_PATH value */
  								/* they will be different if multiple directories are specified */
  			call inidest.text tempStr			/* set screeen to new path */
  			parms.setOdbcPath=1				/* flag config.sys to be updated with variable */
  			parms.msgText1 = "---- Warning: The value in your ODBC_PATH variable "
  			parms.msgText1 = parms.msgText1||"  ("||parms.odbcPath||")  "
       			parms.msgText1 = parms.msgText1||" appears to point to more than one directory. It will be updated to "||tempStr
  		end
  	end
  	else do
  		if (pos(";",parms.odbcpath)>0) then do
  			parms.msgText1 = "---- Warning: The value in your ODBC_PATH variable "
  			parms.msgText1 = parms.msgText1||"  ("||parms.odbcPath||")  "
       			parms.msgText1 = parms.msgText1||" appears to point to more than one directory and ODBCINST.INI cannot be found in any of the directories"
  			parms.msgText1 = parms.msgText1||".  It will be updated to "||sysbootdrive()||"\OS2"
  			parms.setOdbcPath=1
  			call  inidest.text sysbootdrive()||"\OS2"	
  		end
  		parms.odbcinst = inidest.text()||"\ODBCINST.INI"
  	end
  
  	if (i = 0) then call inidest.disable
  end
  else do			/*  no ODBC_PATH currently set */
  	parms.odbcinst = inidest.text()||"\ODBCINST.INI"
  	parms.setOdbcPath=1			/* set flag for setting ODBC_PATH in config.sys */
  end
  
  /*  Now check for existing ODBC installation - first the administrator */
  flag2 = 0
  tempStr = ''
  xx = rxSearchPath("ODBCADM.EXE",sysbootdrive()||"\ODBC\BIN")
  parse value xx with i tempStr
  if (i=0) then do  
  
  	flag2 = 1
  end
  if (flag2=0) then do
  	xx = rxSearchPath("ODBCADM.EXE",sysbootdrive()||"\ODBC")
  	parse value xx with i tempStr
  	if (i = 0) then flag2 = 1
  
  end
  if (flag2=0) then do
  	xx = rxSearchPath("ODBCADM.EXE","PATH","V")
  	parse value xx with i tempStr
  	if (i = 0) then flag2 = 1
  
  end
  if (flag2 = 1) then do
  	parms.odbcadm = tempStr		/* save path/filename of administrator */					
  	parms.msgText2 = d2c(10)||d2c(13)||"---- Information: It appears that you already have a version "
  
  	rc1 = sysfiletree(tempStr,resultvar,'F')	/* check for the existence of ODBC.EXE */
  	if (resultvar.0 = 1) then do
  		i = 0
  		i = substr(resultvar.1,24,7)
  		if (i < 29000) then parms.msgText2=parms.msgText2||'2.5 or earlier ODDBC'
  		if (i >= 29000) then parms.msgText2=parms.msgText2||'3.0 ODBC'
  	end
  	tempStr = translate(substr(tempStr,1,length(tempStr)-12)) /* split off path from path/filename */
  
  	call destinations.exedest.text tempStr
  
  	parms.msgText2 = parms.msgText2||' Administrator in '||tempStr
  end
  
  
  /*  ----- Look for where drivers are installed ------- */
  flag2 = 0
  if (parms.odbcinst \= '') then do
  	rc = sysini(parms.odbcinst,'ALL:','resultvar')
  	if (resultvar.0>0) then do
  		flag2 = 1		/* set flag to indicate existing drivers */
  		tempStr = ''
  		do i=1 to resultvar.0	/* look for intersolv drivers - if found get the directory where the driver DLL is located */
  			if (pos("INTERSOLV",translate(resultvar.i))>0) then do
  				tempStr = sysini(parms.odbcinst,resultvar.i,'Driver')
  				leave		
  			end
  		end
  		if (tempStr = '') then do	/* no intersolv drivers found */
  			do i=1 to resultvar.0
  				if (i=1) then   tempStr1 = sysini(parms.odbcinst,resultvar.i,'Driver')
  				if (i=2) then  do
  					tempStr2 = sysini(parms.odbcinst,resultvar.i,'Driver')
  					leave
  				end					
  			end
  			if (resultvar.0 = 1) then do
  				if (tempStr1 \= '') then   tempStr = tempStr1
  			end
  			else do
  				if (tempStr1 \= '') & (tempStr1 = tempStr2) then   tempStr = tempStr1
  			end
  			
  		end
  		installedList.0 = 0
  		rc = sysini(parms.odbcinst,'ODBC Drivers','ALL:','installedList')
  		/*  remove terminating null, if present and blanks if present */
  		if (installedList.0>0) then do
  			do i=1 to installedList.0
  				installedList.i = strip(changestr('00'x,installedList.i,''))	
  			end
  		end
  		if (rc='ERROR') then do
  			flag2 = 0
  			parms.msgText4 = d2c(10)||d2c(13)||"---- Information: It appears that the ODBCINST.INI file is corrupt. Delete the file and restart this program"
  		end
  	end
  end
  
  
  if (flag2 = 1) then do
  	if (tempStr \= '') then  tempStr = translate(substr(tempStr,1, (lastpos('\',tempStr)-1) )    )
  	parms.msgText4 = d2c(10)||d2c(13)||"---- Information: It appears that you already at least one ODBC Database Driver"
  	parms.msgText4 = parms.msgText4||' installed in '||tempStr
  	
  	/* if found a directory with more than one (or all) drivers in the directory set the screen to that directory */
  	if (tempStr \= '') then call destinations.driversdest.text tempStr
  
  	parms.page3 = main.notebook.add(0,"L","DRIVERSCOVERPAGE","Drivers");
  	parms.pageX = main.notebook.add(parms.page3,"n","DRIVERS","Available to Install ","Source page is blank - no drivers");
  	parms.page4 = main.notebook.add(parms.pagex,"n","INSTALLED","Already Installed","Select one or more drivers to delete");
  
  	if (installedList.0>0) then do
  		do i=1 to installedList.0
  			call installed.installedDriverList.add installedList.i, "A"
  		end
  	end
  
  end
  else do
  	parms.pageX = main.notebook.add(0,"L","DRIVERS","Drivers","Source page is blank - no drivers");
  	call destinations.driversdest.text sysbootdrive()||"\ODBC"
  end
  
  /* ---- Look for ODBC driver manager (ODBC.DLL) ------- */
  flag2 = 0
  resultvar.0 = 0
  i = 0
  rc = sysfilesearch( 'LIBPATH', sysbootdrive()||"\CONFIG.SYS", "resultvar.")
  if (rc<3) then do
  	rc = pos("LIBPATH",translate(resultvar.1))
  	if (rc>0) then do
  		xx = rxSearchPath("ODBC.DLL",substr(resultvar.1,i+1))
  		parse value xx with i tempStr
  		if (i = 0) then 	flag2 = 1
  	end
  	if (i=0) then do
  		/*  check the size of ODBC.DLL to ascertain if it is iODBC */
  		rc1 = sysfiletree(tempStr,resultvar,'F')
  		if (resultvar.0 = 1) then do
  			i = 0
  			i = substr(resultvar.1,24,7)
  			if (i < 100000) then do 		/* iODBC type ODBC.DLL is (hopefully) sized less than 100,000 bytes */
  							/* Its either the size or open the file an read the first 88 bytes looking for German phrase... size is quicker */
  				parms.msgText3 = d2c(10)||d2c(13)||"---- Warning: It appears that you already have the iODBC driver manager installed in "||tempStr||". This driver manager cannot be used with regular ODBC drivers and must be replaced or deleted."
  				/* set the DLL destination = the drivers destinition */
  				call destinations.dlldest.text  destinations.driversdest.text()
  			end
  			else do 
  				parms.msgText3 = d2c(10)||d2c(13)||"---- Information: It appears that you already have the ODBC"
  				parms.msgText3 = parms.msgText3||' Driver Manager in '||tempStr
  				parms.odbcdll = tempStr
  				/* set the DLL destination to the path where we found the existing ODBC.DLL file */
  		        		tempStr = translate(substr(tempStr,1,length(tempStr)-9)) /* split off path from path/filename */
  				call destinations.dlldest.text tempStr
  			end
  
  		end
  
  	end
  end
  
  
  if (parms.msgText1 \= '')|(parms.msgText2 \= '')|(parms.msgText3 \= '')|(parms.msgText4 \= '') then do
  	call main.showmessagesbutton.enabled 1
  	call showMessages
  end
  RETURN

showErrorBox:
  procedure 
  use arg title, helpFile, message
  
  
  call errorBox1.open
  call errorBox1.text title
  call errorBox1.mle.text message
  if (helpFile \= 'HELPFILE') then do
  	parms.tempHelpFile = helpFile
  end
  else
  	call errorBox1.help.disable
  
  return

CheckForDrivers:
  procedure expose fileList. adminList. driverList. DrvSetup. sourceType ODBCAdm. ODBCDrv. parms.  ODBCReq. driverReqList.
  
  call main.msgbox.text 'Checking source for Database Drivers'
  
  bb = 0
  reqList. = ""
  tempList. = 0
  driverReqList. = ''
  
  call drivers.driverlist.delete		/* delete all existing drivers from the list */
  
  
  /* --- Look for Drivers --- */
  
  if (datatype(ODBCDrv.0,"N")=0) then do
  	call main.msgbox.text 'ERROR - Invalid ODBCDrv.0 value. Must be a number'
  	signal errorStop
  	return
  end
  
  /* ---- Add the special driver required files included with this app --- */
  /*        These files are bundled with ODBCINST because some of the    */
  /*       driver bundles are missing a few files                                   */
  
  call addToList parms.curPath "ORA7O32.DLL"
  call addToList parms.curPath "ORA632.DLL"
  call addToList parms.curPath "OSNT32.DLL"
  call addToList parms.curPath "LITB32.DLL"
  call addToList parms.curPath "COREO32.DLL"
  
  
  
  /* --- see if Watcom SQL 4 is installed on this machine -- add to list of files */
  /******
  tempStr = value('WSQL',,'OS2ENVIRONMENT')
  if (tempStr \= '') then do
  	tempStr = stripSlash(tempStr)||"\OS2\" 
  	call addToList tempStr  'WOD40220.DLL'
  	call addToList tempStr  'WSQLODBC.HLP'
  end
  *****/
  /* --- see if Sybase SQL Anywhere 5 is installed on this machine -- add to list of files */
  /******
  tempStr = value('SQLANY',,'OS2ENVIRONMENT')
  if (tempStr \= '') then do
  	tempStr = stripSlash(tempStr)||"\OS2\" 
  	call addToList tempStr  'WOD502.DLL'
  end
  *****/
  
  
  
  
  do i=1 to ODBCDrv.0 			/* loop through list of driver files */
  /* say 'Looking for ' odbcdrv.i.1  '  ' odbcdrv.i.a  */
  	if (datatype(ODBCDrv.i.0)=0) then do
  		call main.msgbox.text 'Invalid ODBCDrv.'||i||'.0 value. Must be a number'
  		return
  	end
  	xx = ODBCDrv.i.0		/* number of files for this driver */
  	if (xx = 0) then iterate		/* bypasses place holder entries in driver file */
  	do z=1 to xx			/* loop through list of required files for this driver */
  		okFlag = 0
  		skipFlag = 0
  		do k=1 to  fileList.0		/* loop through files in source */
  			call processFiles3
  			if (z=1) then do
  				if (ODBCDrv.i.A \= '') then do		/* alternate driver bundle */
  					if (tempStr = ODBCDrv.i.a) | (pos("/"||ODBCDrv.i.a,tempStr)>0)  then do
  						okFlag = 1
  						skipFlag = 1
  						tempList.1 = k
  						leave
  					end
  				end
  			end
  			if (ODBCDrv.i.z \= '') then do	/* prevents errors from incorrectly code ODBCDrv file/stem variable (missing element or incorrect .0 number) */	
  				if (tempStr = ODBCDrv.i.z) | (pos("/"||ODBCDrv.i.z,tempStr)>0) | (pos("\"||ODBCDrv.i.z,tempStr)>0) then do
  					okFlag = 1
  					tempList.z = k	   /* save index of fileList */
  					leave
  				end
  			end
  		end
  		if (okFlag=0) then do
  /*	say 'Missing file 'ODBCDrv.i.z */
  			leave	/* error - a file was not found - don't look any more*/
  		end
  		if (skipFlag = 1) then leave	/* found the alternate file */
  	end
  	if (okFlag=1) then call processFile2
  end
  
  if (substr(parms.debug,2,1)='X')  then  do
  	say ' ----- List of found Driver Files ----'
  	do i=1 to bb
  		say ' ### ' i ' ' driverList.i.t
  		say '    setup=' driverList.i.s	 ' numOfFiles=' driverList.i.0
  
  		do x=1 to driverList.i.0
  			say '    driverList.'||i||'.'||x||'=' driverList.i.x
  		end
  		say '    required Files (' driverList.i.r ')'
  		if (driverList.i.r \= '') then do
  			say  '        driverReqList.'||uu||".0=" driverReqList.uu.0
  			ww = words(driverList.i.r)
  			do xx = 1 to ww
  				wrd = word(driverList.i.r,xx) 
  				do uu = 1 to driverReqList.wrd.0
  					say '        ' driverReqList.wrd.uu
  				end
  			end
  		end
  	end
  	say ' ----------------------------------'
  end
  
  
  
  call main.msgbox.text ''
  return
  
  /* ------ Transfer all source file names for required files for found driver */
  /*           to driverList.   This stem variable is used to copy the files to the */
  /*	   destination */		
  processFile2:
  
  if (ODBCDrv.i.r \= "") then do		/*  check required files */
  	ww = words(ODBCDrv.i.r)
  	rok = 1
  	do cnt=1 to ww
  		wrd = word(ODBCDrv.i.r,cnt)	/* get required list */	
  		if (reqList.wrd = "") then call checkReq
  		if (reqList.wrd = "N") then do
  			rok = 0
  			leave
  		end
  	end
  	if (rok = 0)  then do
  		return		/* missing one or more required files */
  	end
  end
  bb  = bb + 1
  yy=0
  do z=1 to xx			/* loop through files and place then in driverList.bb */
  	yy = z
  	uu = tempList.z		/* retrieve index of source file */
  	if (parms.sourceType = 2) then do
  		driverList.bb.z = strip(substr(fileList.uu,58))
  		if (substr(driverList.bb.z,1,1) = "^") then driverList.bb.z = substr(driverList.bb.z,2)
  	end
  	else   do
  		driverList.bb.z =  strip(substr(fileList.uu,38))
  	end
  	if (skipFlag=1) then leave
  end
  
  driverList.bb.0 = yy
  driverlist.bb.t = ODBCDrv.i.t		/* save the title */
  driverList.bb.s = ODBCDrv.i.s		/* save setup index */
  driverList.bb.q = i			/* save index back into ODBCDrv */
  if (ODBCDrv.i.r \= '') then do		/* save Required files */
  	driverList.bb.r = ODBCDrv.i.r
  end
  	
  /*  Add this driver to the driver selection list */
  call drivers.driverlist.add ODBCDrv.i.t, "L", z
  
  driverList.0 = bb
  return
  
  processFiles3:
  if (parms.sourceType=2) then tempStr = translate(substr(fileList.k,58))
  else tempStr = translate(substr(fileList.k,lastpos("\",fileList.k)+1))
  /*
  say 'tempStr='||tempStr '   fileList='||fileList.k
  */
  return
  
  
  /*  Check the files in the required list. If all the files are there flag the */
  /* reqList.wrd as OK, otherwise flag as not OK. This is so that the required list */
  /* is only checked once, the first time needed */
  
  checkReq:
  cntFlag = 0
  tempReqList. = 0
  altFlag = 0
  do ff = 1 to ODBCReq.wrd.0			/* loop through required files in this group */
  	do k=1 to fileList.0
  		call processFiles3
  		if (ODBCReq.wrd.A \= '') then do
  			if (tempStr = ODBCReq.wrd.A) | (pos("/"||ODBCReq.wrd.A,tempStr)>0) then do
  				cntFlag = ODBCReq.wrd.0	/* set the count = all the files in the group - to satisfy the next section */
  				tempReqList.ff = k
  				altFlag=1	
  				leave
  			end
  		end
  		if (ODBCReq.wrd.ff \= '') then do	/* prevents errors from incorrectly coded ODBCReq file/stem variable (missing element or incorrect .0 number) */	
  			if (tempStr = ODBCReq.wrd.ff) | (pos("/"||ODBCReq.wrd.ff,tempStr)>0) then do
  				cntFlag = cntFlag + 1
  				tempReqList.ff = k	
  				leave
  			end
  		end		
  	end
  	if (cntFlag \=ff) then leave
  	if (altFlag = 1) then leave
  end
  if (cntFlag = ODBCReq.wrd.0) then do		/* all required files found */
  	reqList.wrd = 'Y'
  	if (altFlag = 1) then cntFlag = 1	/* only one file is in the list when the  alternate file is processed */
  	else 	cntFlag = ODBCReq.wrd.0
  	do ff = 1 to cntFlag
  		uu = tempReqList.ff
  		if (parms.sourceType = 2) then do		/*  zip source file */
  			driverReqList.wrd.ff = substr(fileList.uu,58)
  			if (substr(driverReqList.wrd.ff,1,1) = "^") then driverReqList.wrd.ff = substr(driverReqList.wrd.ff,2)
  		end
  		else     driverReqList.wrd.ff = strip(substr(fileList.uu,38))
  	end
  	driverReqList.wrd.0 = cntFlag
  end
  else    reqList.wrd = 'N'			/* all required files not found */
  return
  
  
  
  
  
  RETURN

makeSetupList:
  procedure expose DrvSetup. parms. 
  arg filename
  DrvSetup. = ''
  DrvSetup.0 = 0
  
  rc = 0
  
  rc = RxPassByName(parms.slist,"&DrvSetup.")
  
  if (rc = '')| (length(rc)>4)   then rc = 0
  if (rc = 0) then signal errorStop3
  
  parms.driverSetup=1
  return rc

makeDriverList:
  procedure expose ODBCDrv. parms. ODBCReq.
  arg filename
  
  ODBCDrv. = ''
  ODBCDrv.0 = 0
  
  rc = 0
  /*  Call external Rexx file to populate the ODBCDrv and ODBCReq stem variables */
  /* The Rxu function below causes those stem variables to have their values */
  /* passed back to this procedure */
  
  rc = RxPassByName(filename,"&ODBCDrv. &ODBCReq.")
  if (rc = '')| (length(rc)>4)   then rc = 0
  
  if (rc = 0) then signal errorStop2
  return rc
  
  
  RETURN

makeAdminList:
  ODBCAdm.1 = "ODBC.DLL"
  ODBCAdm.2 = "ODBCINST.DLL"
  ODBCAdm.3 = "ODBCADM.EXE"
  ODBCAdm.4 = "ODBCCP.DLL"
  ODBCAdm.5 = "OS2UTIL.DLL"
  ODBCAdm.6 = "ODBCINT.DLL"
  ODBCAdm.7 = "ODBCCR.DLL"
  ODBCAdm.8 = "ODBCINST.HLP"
  ODBCAdm.9 = "ODBC.LIB"
  
  ODBCAdm.10 = "ODBC.DL_"
  ODBCAdm.11 = "ODBCINST.DL_"
  ODBCAdm.12 = "ODBCADM.EX_"
  ODBCAdm.13 = "ODBCCP.DL_"
  ODBCAdm.14 = "OS2UTIL.DL_"
  ODBCAdm.15 = "ODBCINT.DL_"
  ODBCAdm.16 = "ODBCCR.DL_"
  ODBCAdm.17 = "ODBCINST.HL_"
  ODBCAdm.18 = "ODBC.LI_"
  ODBCAdm.19 = "CPPOM30.DL_"
  
  
  ODBCAdm.20 = "IOM.DLL"
  ODBCAdm.21 = "IPPOM30.DLL"
  ODBCAdm.22 = "IBUTL08.DLL"
  ODBCAdm.23 = "IVUTL08.DLL"
  ODBCAdm.24 = "IBBAS08.DLL"
  ODBCAdm.25 = "IVBAS08.DLL"
  ODBCAdm.26 = "IBUTL12.DL_"
  ODBCAdm.27 = "IBBAS12.DL_"
  ODBCAdm.28 = "IBFLT12.DL_"
  ODBCAdm.29 = "IOM.DL_"
  
  ODBCAdm.30 = "IVBAS.ZIP"
  ODBCAdm.31 = "ODBCADM.ZIP"
  
  
  ODBCAdm.0 = 31
  RETURN

install:
  procedure expose  adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList.  DrvSetup.
  /*  This starts the install process */
  
  
  parms.overSkip = 0
  call main.msgBox.text ''		/* clear message box */
  reqLst. = ' N'
  reqLst.0 = 0
  
  if (substr(parms.debug,3,1)='X') then say '----------- Installing Files --------------'
  
  /* ------ directory is specified as source ------- */
  if (parms.sourceType = 1) then do
  		
  	/*   Admin and Driver Manager first */
  	if (source.inst_admin.select() = 1) & (parms.exeOK=1) & (parms.dllOK=1) then do
  		call main.msgBox.text 'Installing Administrator and Driver Manager'		/* clear message box */
  		do i=1 to adminList.0
  			if (length(adminList.i)>10)  then tempStr=substr(adminList.i,length(adminList.i)-10)
  			else    tempStr = adminList.i 
  			if (tempStr = 'ODBCADM.ZIP')  then do		/* special processing for DEMO type admin package */
  				call doZipFile adminList.i "ODBCADM.EXE" Destinations.exedest.text()
  				call doZipFile adminList.i "ODBCINST.HLP" Destinations.exedest.text()	
  				call doZipFile adminList.i "ODBCINST.DLL" Destinations.dlldest.text()
  				call doZipFile adminList.i "ODBC.DLL" Destinations.dlldest.text()	
  				call doZipFile adminList.i "ODBC.LIB" Destinations.dlldest.text()
  				iterate	
  			end
  			if (substr(adminList.i,length(adminList.i)-3,4) = '.ZIP') then do
  				'@unzip -jo '||parms.fileEntry||" "||adminList.i||"  -d "||parms.tempPath	
  				tempStr = changeStr("/",adminList.i,"\")
  				xpos = lastpos("\",tempStr)
  				if (xpos>0) then tempStr = substr(tempStr,xpos+1)
  				call doZipFile  parms.tempPath||"\"||tempstr "*.exe" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.EXE" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.HLP" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.hlp" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.dll" Destinations.dlldest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.DLL" Destinations.dlldest.text()
  				'attrib -r ' parms.tempPath||"\"||tempStr
  				call sysfiledelete parms.tempPath||"\"||tempStr
  				iterate
  			end
  
  			if (substr(adminList.i,length(adminList.i)-3,4) = '.ZIP') then do
  				call doZipFile adminList.i '-'  Destinations.dlldest.text()
  				iterate	
  			end
  			if (substr(adminList.i,length(adminList.i),1) = '_') then do
  				call doUnpackFile  adminList.i Destinations.dlldest.text()
  				iterate	
  			end
  			call doCopyFile  adminList.i Destinations.dlldest.text()
  
  		end
  	end
  	/*   ----- Database Drivers ------ */
  	if (parms.driversOK=1) & (drivers.driverList.select()>0) then do
  		call main.msgBox.text 'Installing database driver(s)'	
  		/*  -- once only per session fill in setup variable -- */
  		if (parms.driverSetup \= 1) then call makeSetupList
  		do tt=0 to 9999
  			tt = drivers.driverList.select(tt,"N")		/* get next selected item */
  			if (tt=0) then leave
  			do i = 1 to driverList.tt.0
  				if (substr(driverList.tt.i,length(driverList.tt.i)-3,4) = '.ZIP') then do
  					call doZipFile driverList.tt.i '-'  Destinations.driversdest.text()
  					if (driverList.tt.i.r \= '') then call install2 i tt
  					iterate	
  				end
  				if (substr(driverList.tt.i,length(driverList.tt.i),1) = '_') then do
  					call doUnpackFile  driverList.tt.i Destinations.driversdest.text()
  					if (driverList.tt.i.r \= '') then call install2 i tt
  					iterate	
  				end
  				call doCopyFile  driverList.tt.i Destinations.driversdest.text()
  			end
  			if (substr(parms.debug,3,1)='X') then say 'Required files? ' driverList.tt.r
  			if (driverList.tt.r \= '') then call install2 tt
  			call setupINI   driverList.tt.s   tt
  		end
  	end
  end
  
  /* ------ zip file is specified as source ------- */
  if (parms.sourceType = 2) then do	
  	/*   Admin and Driver Manager first */
  	if (source.inst_admin.select() = 1) & (parms.exeOK=1) & (parms.dllOK=1) then do
  		call main.msgBox.text 'Installing Administrator and Driver Manager'
  		do i=1 to adminList.0
  			if (substr(adminList.i,2,1) = ':') then do	     /* special files included in ODBCINST.EXE package */
  
  				if (substr(adminList.i,length(adminList.i)-3,4) = '.DLL') then do
  					call doCopyFile adminList.i  Destinations.dlldest.text()
  				end
  				else do
  					call doCopyFile adminList.i  Destinations.exedest.text()
  				end
  				iterate
  			end
  
  			/*  these sections are here calling out files specifically to avoid wierd overwrite prompt messages */
  			/*  that can happen in the generic *.ZIP  section below */
  			if (length(adminList.i)>10)  then tempStr = substr(adminList.i,length(adminList.i)-10)
  			else tempStr = adminList.i 
  
  			if (tempStr = 'ODBCADM.ZIP')  then do
  				'@unzip -jo '||parms.fileEntry||" "||adminList.i||"  -d "||parms.tempPath
  				call doZipFile  parms.tempPath||"\ODBCADM.ZIP" "ODBCADM.EXE" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\ODBCADM.ZIP" "ODBCINST.HLP" Destinations.exedest.text()	
  				call doZipFile  parms.tempPath||"\ODBCADM.ZIP" "ODBCINST.DLL" Destinations.dlldest.text()
  				call doZipFile  parms.tempPath||"\ODBCADM.ZIP" "ODBC.DLL" Destinations.dlldest.text()	
  				call doZipFile  parms.tempPath||"\ODBCADM.ZIP" "ODBC.LIB" Destinations.dlldest.text()
  				'attrib -r ' parms.tempPath||"\ODBCADM.ZIP"
  				call sysfiledelete parms.tempPath||"\ODBCADM.ZIP"
  				iterate	
  			end
  
  			if (length(adminList.i)>9)  then tempStr = substr(adminList.i,length(adminList.i)-9)
  			else        tempStr = adminList.i 
  
  			if (tempStr = 'IVBAS.ZIP')  then do
  				'@unzip -jo '||parms.fileEntry||" "||adminList.i||"  -d "||parms.tempPath
  				call doZipFile  parms.tempPath||"\IVBAS.ZIP" "IVINFO.EXE" Destinations.exedest.text()								call doZipFile  parms.tempPath||"\IVBAS.ZIP" "IPPOM30.DLL" Destinations.dlldest.text()
  				call doZipFile  parms.tempPath||"\IVBAS.ZIP" "IVBAS08.DLL" Destinations.dlldest.text()	
  				call doZipFile  parms.tempPath||"\IVBAS.ZIP" "IOM.DLL" Destinations.dlldest.text()
  				call doZipFile  parms.tempPath||"\IVBAS.ZIP" "IPPOM30.DLL" Destinations.dlldest.text()
  				call doZipFile  parms.tempPath||"\IVBAS.ZIP" "IVFLT08.DLL" Destinations.dlldest.text()
  				call doZipFile  parms.tempPath||"\IVBAS.ZIP" "IVUTL08.DLL" Destinations.dlldest.text()
  				'attrib -r ' parms.tempPath||"\IVBAS.ZIP"
  				call sysfiledelete parms.tempPath||"\IVBAS.ZIP"
  				iterate	
  			end
  
  
  			/*  If the admin file (in the zipped source file) is a packed file */
  			if (substr(adminList.i,length(adminList.i),1) = '_') then do
  				'@unzip -jo '||parms.fileEntry||" "||adminList.i||"  -d "||parms.tempPath
  				tempStr = changeStr("/",adminList.i,"\")
  				xpos = lastpos("\",tempStr)
  				if (xpos>0) then tempStr = substr(tempStr,xpos+1)
  				tempStr = translate(strip(tempStr))
  				if (substr(tempStr,length(tempStr)-3,4) = '.DL_') then 	call doUnpackFile  parms.tempPath||"\"||tempStr Destinations.dlldest.text()
  				if (substr(tempStr,length(tempStr)-3,4) = '.HL_') then 	call doUnpackFile  parms.tempPath||"\"||tempStr Destinations.exedest.text()
  				if (substr(tempStr,length(tempStr)-3,4) = '.EX_') then 	call doUnpackFile  parms.tempPath||"\"||tempStr Destinations.exedest.text()				
  				'attrib -r ' parms.tempPath||"\"||tempStr
  				call sysfiledelete parms.tempPath||"\"||tempStr
  				iterate	
  			end
  			if (substr(adminList.i,length(adminList.i)-3,4) = '.ZIP') then do
  				'@unzip -jo '||parms.fileEntry||" "||adminList.i||"  -d "||parms.tempPath	
  				tempStr = changeStr("/",adminList.i,"\")
  				xpos = lastpos("\",tempStr)
  				if (xpos>0) then tempStr = substr(tempStr,xpos+1)
  				call doZipFile  parms.tempPath||"\"||tempstr "*.exe" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.EXE" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.HLP" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.hlp" Destinations.exedest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.dll" Destinations.dlldest.text()
  				call doZipFile  parms.tempPath||"\"||tempstr "*.DLL" Destinations.dlldest.text()
  				'attrib -r ' parms.tempPath||"\"||tempStr
  				call sysfiledelete parms.tempPath||"\"||tempStr
  				iterate
  			end
  			call doZipFile  parms.fileEntry adminList.i Destinations.dlldest.text()
  
  
  		end
  	end
  	/*   Drivers */
  	if (parms.driversOK=1) & (drivers.driverList.select()>0) then do
  		call main.msgBox.text 'Installing database drivers'
  		/*  -- once only per session fill in setup variable -- */
  		if (parms.driverSetup \= 1) then call makeSetupList
  		do tt=0 to 9999
  			tt = drivers.driverList.select(tt,"N")		/* get next selected item */
  			if (tt=0) then leave
  			do i = 1 to driverList.tt.0
  				if (substr(driverList.tt.i,2,1) = ':') then do	/* special files included in ODBCINST.EXE package */
  					call doCopyFile driverList.tt.i  Destinations.driversdest.text()
  					iterate
  				end
  				/*   the driver file is actually a zip file itself */
  				if (substr(driverList.tt.i,length(driverList.tt.i)-3,4) = '.ZIP') then do
  					'@unzip -jo '||parms.fileEntry||" "||driverList.tt.i||"  -d "||parms.tempPath
  					tempStr = changeStr("/",driverList.tt.i,"\")
  					xpos = lastpos("\",tempStr)
  					if (xpos>0) then tempStr = substr(tempStr,xpos+1)
  					call doZipFile parms.tempPath||"\"||tempStr '-'  Destinations.driversdest.text()
  					'attrib -r ' parms.tempPath||"\"||tempStr
  					call sysfiledelete parms.tempPath||"\"||tempStr
  					iterate
  				end
  				/*  the driver file is a packed file */
  				if (substr(driverList.tt.i,length(driverList.tt.i),1) = '_') then do
  					'@unzip -jo '||parms.fileEntry||" "||driverList.tt.i||"  -d "||parms.tempPath
  					tempStr = changeStr("/",driverList.tt.i,"\")
  					xpos = lastpos("\",tempStr)
  					if (xpos>0) then tempStr = substr(tempStr,xpos+1)
  					call doUnpackFile  parms.tempPath||"\"||tempStr Destinations.driversdest.text()
  					'attrib -r ' parms.tempPath||"\"||tempStr
  					call sysfiledelete parms.tempPath||"\"||tempStr
  					iterate	
  				end
  				/* whew  -  the driver file is just a regular old file */
  				call doZipFile  parms.fileEntry driverList.tt.i Destinations.driversdest.text()
  			end
  			if (substr(parms.debug,3,1)='X') then say 'Required files? ' driverList.tt.r
  			if (driverList.tt.r \= '') then call install2 tt
  			call setupINI driverList.tt.s tt
  		end
  	end
  end
  
  
  /*  update config.sys and install desktop icons */
  call install3
  
  call updateInstalledDriversList
  
  call main.msgBox.text 'Install complete'
  return
  
  
  RETURN

stripSlash:
  procedure
  arg inVal
  
  inVal=strip(inVal)
  
  if (length(inVal)<4) then return inVal
  if (substr(inVal,length(inVal),1) = '\' ) then do
     inVal = substr(inVal,1,(length(inVal)-1))
  end
  return inVal
  
  
  RETURN

makeDirectories:
  if (parms.iniOK=0) then do
  	errorFlag = sysmkdir(destinations.inidest.text())
  	if (errorFlag \= 0) then call chkRcDir errorFlag "ODBC INI "
  	else parms.iniOK=1
  end 
  if (parms.exeOK=0) then do
  	errorFlag = sysmkdir(destinations.exedest.text())
  	if (errorFlag \= 0) then call chkRcDir errorFlag "ODBC Executables "
  	else parms.exeOK=1
  end 
  if (parms.dllOK=0) then do
  	errorFlag = sysmkdir(destinations.dlldest.text())
  	if (errorFlag \= 0) then call chkRcDir errorFlag "ODBC DLLs "
  	else parms.dllOK=1
  end 
  if (parms.driversOK=0) then do
  	errorFlag = sysmkdir(destinations.driversdest.text())
  	if (errorFlag \= 0) then call chkRcDir errorFlag "ODBC Drivers "
  	else parms.driversOK=1
  end 
  call main.msgBox.text 'Directory(s) created'
  call checkInstallButton
  
  signal return
  
  chkRCDir: procedure
  arg inrc msgText
  
  select
  	when inrc = 2 then call main.msgbox.text msgText||" Error - File not found"
  	when inrc = 3 then call main.msgbox.text msgText||" Error - Path/drive not found"
  	when inrc = 5 then call main.msgbox.text msgText||" Error -Access denied not found"
  	when inrc = 26 then call main.msgbox.text msgText||" Error -Not a DOS disk"
  	when inrc = 87 then call main.msgbox.text msgText||" Error -Invalid parameter"
  	when inrc = 108 then call main.msgbox.text msgText||" Error -Drive locked"
  	when inrc = 206 then call main.msgbox.text msgText||" Error -Filename exceeds range"
  	otherwise
  end
  return
  
  
  RETURN

checkDirectories:
  if (parms.iniOK=0) | (parms.exeOK=0) | (parms.driversOK=0)|(parms.dllOK=0) then call destinations.createDirectories.enable
  else call destinations.createDirectories.disable
  RETURN

checkDriversDest:
  resultvar.0 = 0
  if (length(driversdest.text())>0) then do
  	call  sysfiletree destinations.driversdest.text(), resultvar, 'D'
  	if (resultvar.0 > 0) then parms.driversOK=1
  	else parms.driversOK=0
  end
  else parms.driversOK=0
  RETURN

checkExeDest:
  resultvar.0 = 0
  
  if (length(exedest.text())>0) then do
  	call  sysfiletree destinations.exedest.text(), resultvar, 'D'
  	if (resultvar.0 > 0) then parms.exeOK=1
  	else parms.exeOK=0
  end
  else parms.exeOK=0
  RETURN

checkIniDest:
  resultvar.0 = 0
  if (length(inidest.text())>0) then do
  	call  sysfiletree destinations.inidest.text(), resultvar, 'D'
  	if (resultvar.0 > 0) then parms.iniOK=1
  	else parms.iniOK=0
  end
  else parms.iniOK=0
  RETURN

checkInstallButton:
  if (parms.iniOK=1) then do	/* ODBC INI directory must be entered to install anything */
  	if (source.inst_admin.select() = 1) & (parms.exeOK=1) & (parms.dllOK=1)then do
  		call main.installButton.enable
  	end
  	else do
  		if (parms.driversOK=1) & (drivers.driverList.select()>0) then do
  			call main.installButton.enable
  		end
  		else do
  			call main.installButton.disable
  		end
  	end
  end
  else call main.installButton.disable
  RETURN

checkForAdmin:
  procedure expose fileList. adminList. driverList. DrvSetup. sourceType ODBCAdm. ODBCDrv. parms.  ODBCReq. driverReqList.
  
  
  if fileList.0 = 0 then return
  
  aa = 0
  
  adminList. = ''
  adminList.0 = 0
  driverList. = ''
  driverList.0 = 0
  
  tempStr = changeStr("/",parms.fileEntry,"\")
  xpos = lastpos("\",tempStr)
  if (xpos>0) then tempStr = substr(tempStr,xpos+1)
  
  if ( tempStr = 'ODBCDEMO.ZIP') then do
  	call addToList parms.curPath "OS2UTIL.DLL"
  end
  
  do k=1 to fileList.0
  	/*  --- If source is a file, then strip off beginning stuff from the line */
  	if (parms.sourceType=2) then tempStr = translate(substr(fileList.k,58))
  	else tempStr = translate(substr(fileList.k,lastpos("\",fileList.k)+1))
  
  	/* look for Admin stuff --- */
  	if (aa < ODBCAdm.0) then do
  		aflag = 0
  		do i=1 to ODBCAdm.0
  			if (tempStr = ODBCAdm.i) | (pos("/"||ODBCAdm.i,tempStr)>0)  | (pos("\"||ODBCAdm.i,tempStr)>0) then do
  				call processFile1
  				aflag = 1
  				leave
  			end
  		end
  		if (aflag = 1) then iterate
  	end
  	
  end
  
  if (substr(parms.debug,1,1)='X') then do
  	say ' ----- ('||aa||') ODBC Admin DrvMng Files Found -------'
  	do i=1 to aa
  		say '     adminList.'||i'=' adminList.i
  	end
  	say ' -------------------------------------------'
  end
  
  return aa
  
  processFile1:
  
  aa  = aa + 1
  if (parms.sourceType = 2) then do
  	adminList.aa = strip(substr(fileList.k,58))
  	if (substr(adminList.aa,1,1) = "^") then adminList.aa = substr(adminList.aa,2)
  end
  else     adminList.aa = parms.fileEntry||"\"||tempStr
  
  
  adminList.0 = aa
  return
  
  
   
  RETURN

checkSource:
  procedure expose adminList. ODBCDrv. parms. flags. ODBCReq. driverList. driverReqList.
  parms.fileEntry = source.sourceentry.text()  		/* get value in source entry box */
  
  
  
  /* ---- For Drives strip off trailing slash, if present --- */
  /* ---- Allow for consistent processing below             */
  if (length(parms.fileEntry) = 3 ) then  parms.fileEntry = substr(parms.fileEntry,1,2)
  
  /*  ---- disable and uncheck the Install ODBC Driver & Admin checkbox  ---- */
  call source.inst_admin.select 0
  call source.inst_admin.enabled 0
  call main.installButton.disable
  
  parms.sourceType = 0			/* 0 = no/invalid source, 1 = directory, 2 = file */
  flags.adminOK = 0
  
  parms.msgtext7 = ''
  if parms.fileEntry = '' then return
  
  /* --- Check if this is a file ----- */
  rc1 = sysfiletree(parms.fileEntry,resultvar,'F')
  if (resultvar.0 = 1) then do
  	if (substr(parms.fileEntry,length(parms.fileEntry)-2,3) \= 'ZIP') then do
  		call main.msgbox.text "Name doesn't end in ZIP - not a zip file?"
  		signal return
  	end
  	parms.sourceType = 2
  end
  else parms.sourceType = 1			/* assume it is a directory */
  
  
  if (parms.sourceType = 0) then do
  	call main.msgBox.text "Error invalid file or directory"
  	signal return
  end
  
  
  
  if (parms.sourceType = 1) then do		/*  directory processing */
  	call main.msgbox.text "Checking contents of directory"
  	rc1 = sysfiletree(parms.fileEntry||"\*.*",fileList,'F')
  	if (fileList.0 = 0) then do
  		call main.msgbox.text "No files in directory or invalid directory"
  		signal errorStop
  	end
  	else do
  		call makeAdminList		/* populates ODBCAdm. variable */
  		call makeDriverList  parms.dlist	
  		call checkForAdmin fileList. adminList.
  		if (adminList.0 >= 6) then do
  			flags.adminOK = 1
  		end
  		else do
  			if (adminList.0 = 3)  then do
  				flags.adminOK = 1
  			end
  			else do
  				call main.msgbox.text 'Missing one or more files'
  				parms.msgtext7 = d2c(10)||d2c(13)||'---- Information: The directory is missing one or more files which prevents the installation of the ODBC Administrator/Driver Manager'
  			end
  		end
  		call main.msgbox.text ''
  	end
  end
  
  if (parms.sourceType = 2) then do					/* file (as opposed to directory */
  	fname = translate(filespec("name",parms.fileEntry))		/* strip off the filename from the path */
  	if (fname = "") then do
  		call main.msgbox.text "Error invalid file name"
  		errorFlag = -1	
  		return
  	end
  	/* determine which type of file */
  	fflag = 0
  	if (translate(fname) = "DAX11.ZIP")       	then do
  		 fflag = 1
  		call main.msgBox.text "Checking contents of DAX11.ZIP"	
  	end
  	if (translate(fname) = "ODBCDEMO.ZIP") 	then do
  		fflag = 2
  		call main.msgBox.text "Checking contents of ODBCDEMO.ZIP"
  	end
  	if (translate(fname) = "ODBCPAK1.ZIP") 	then do
  		fflag = 3
  		call main.msgBox.text "Checking contents of ODBCPAK1.ZIP"
  	end
  	if (translate(fname) = "PSQLODBCOS2.ZIP") 	then do
  		call main.msgBox.text "Checking contents of PostgresSQL 7.01 ODBC file"
  		fflag = 4
  	end
  	if (translate(fname) = "ODBC3_01-BIN_OS2.ZIP") 	then do
  		call main.msgBox.text "Checking contents of PostgresSQL 7.1 ODBC file"
  		fflag = 5
  	end
  	if (fflag = 0) then do
  		if (substr(fname,(length(fname)-2)) = 'ZIP')  then do
  			fflag = 6
  			call main.msgBox.text "Checking contents of unknown zip file"
  		end
  	end
  end
  
  tempFile =  systempfilename(tempPath||"tempInstall_?????.TMP")
  
  if (fflag > 0) then do
  	'unzip -v  '||parms.fileEntry||' > '||tempFile
  	if (fflag=1) then  do				/* DAX11.ZIP */
  		rc = sysfilesearch("odbc/" ,tempFile, fileList)
  		call makeAdminList
  		call  makeDriverList parms.dlist
  		call checkForAdmin
  		if (adminList.0 >= 8) then flags.adminOK = 1;
  		else do 
  			call main.msgbox.text 'Missing one or more files'
  			parms.msgtext7 = d2c(10)||d2c(13)||'---- Information: DAX11.ZIP is missing one or more files which prevents the installation of the ODBC Administrator/Driver Manager'
  		end
  
  	end
  	if (fflag=2) then do				/* ODBCDEMO.ZIP */
  		call sysfilesearch " ", tempFile ,fileList
  		call makeAdminList
  		call makeDriverList parms.dlist
  		call checkForAdmin
  		if (adminList.0 = 3) then do
  			flags.adminOK = 1;
  		end
  		else do
  			call main.msgbox.text 'Missing ODBCADM.ZIP, IVBAS.ZIP or OS2UTIL.DLL'
  			parms.msgtext7 = d2c(10)||d2c(13)||'---- Information: ODBCDEMO.ZIP is missing one or more of the files: ODBCADM.ZIP, IVBAS.ZIP or OS2UTIL.DLL which prevents the installation of the ODBC Administrator/Driver Manager'
  		end
  	end
  	if (fflag=3) then do				/* ODBCPAK1.ZIP */
  		call sysfilesearch "odbcadm.zip", tempFile, fileList
  	end
  	if (fflag=4) then do				/* PSQLODBCOS2.ZIP */
  		call sysfilesearch " ", tempFile, fileList
  		call makeAdminList
  		call makeDriverList parms.dlist		
  		call checkForAdmin
  		if (adminList.0 = 7) then do
  			flags.adminOK = 1
  			call main.msgbox.text ''
  		end
  		else do
  			call main.msgbox.text 'Missing one or more files'
  			parms.msgtext7 = d2c(10)||d2c(13)||'---- Information: PSQLODBCOS2.ZIP is missing one or more of the files: ODBCADM.ZIP, IVBAS.ZIP or OS2UTIL.DLL which prevents the installation of the ODBC Administrator/Driver Manager'
  		end
  
  	end
  	if (fflag=5) then do				/* ODBC3_01-BIN_OS2.ZIP */
  		call sysfilesearch " ", tempFile, fileList
  		call makeAdminList
  		call makeDriverList parms.dlist		
  		call checkForAdmin
  		if (adminList.0 >= 11) then do
  			flags.adminOK = 1
  			call main.msgbox.text ''
  		end
  		else do
  			call main.msgbox.text 'Missing one or more files'
  			parms.msgtext7 = d2c(10)||d2c(13)||'---- Information: ODBC3_01-BIN_OS2.ZIP is missing one or more of the files: ODBCADM.ZIP, IVBAS.ZIP or OS2UTIL.DLL which prevents the installation of the ODBC Administrator/Driver Manager'
  
  		end
  	end
  	if (fflag=6) then do
  		call sysfilesearch " ", tempFile, fileList
  		call makeAdminList
  		call makeDriverList parms.dlist
  
  		call checkForAdmin
  		if (adminList.0 >= 6) then do
  			flags.adminOK = 1
  			call main.msgbox.text ''
  		end
  		else do
  			call main.msgbox.text "Missing one or more files"
  			parms.msgtext7 = d2c(10)||d2c(13)||'---- Information: The zip file is missing one or more of the files: ODBCADM.ZIP, IVBAS.ZIP or OS2UTIL.DLL which prevents the installation of the ODBC Administrator/Driver Manager'
  
  		end
  	end
  	rc = sysfiledelete(tempFile) 
  end
  
  
  
  if (flags.adminOK=1) then do
  	call source.inst_admin.enabled 1
  	call source.inst_admin.select 1
  end
  else   do
  	call source.inst_admin.enabled 0
  	parms.errorMessage = main.msgbox.text()
  	call main.timer 5000
  end
  
  
  call checkForDrivers
  
  call main.notebook.item parms.pageX ,"S", "Select one or more drivers to install"
  
  
  if (flags.adminOK=1) then call checkInstallButton
  else call main.msgbox.text parms.errorMessage
  
  /*** not this release ***
  parms.saveFileEntry = parms.fileEntry		/* save source entry to determine if changed */
  ****/
  
  errorStop:
  
  return

INIT:
  arg inParms
  
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  call SysLoadFuncs
  
  /*  RXU utilties  */
  call rxfuncadd 'rxuinit','rxu','rxuinit'
  call rxuinit
  
  /*  My interface to DosCopy  */
  call RxFuncAdd 'COPYFILE', 'RXIODGC', 'COPYFILE'
  rc =  RxFuncAdd('COPYFILE', 'RXIODGC', 'COPYFILE')
  
  
  parms. = ""
  parms.page1 = 0
  parms.page2 = 0
  parms.page3 = 0
  parms.page4 = 0
  parms.page5 = 0
  
  /* pos  1=admin files found, 2= driver files found, 3 = show install files, 4 = show required files installed, 5 = show setup */
  adminList. = ''
  adminList.0 = 0
  retcode = 0
  
  xx = rxSearchPath("ODBCINST.EXE","PATH","CV")
  parse value xx with i tempStr
  if (i=0) then do
  	parms.curpath = translate(substr(tempStr,1,length(tempStr)-12))
  end
  parms.iniOK=0			/* destination path of ODBC ini files is ok */
  parms.exeOK=0			/* destination path of ODBC exes is ok */
  parms.driversOK=0		/* destination path of ODBC drivers is ok */
  
  parms.dlist = parms.curpath||"ODBCDrv1"
  parms.slist = parms.curpath||"ODBCDrv2"
  
  parse value inParms with in1 ' ' in2 ' ' in3
  
  call doParms in1
  call doParms in2
  call doParms in3
  
  
  parms.tempPath= value("TEMP",,"OS2ENVIRONMENT")
  if (parms.tempPath = "") then value("TMP",,"OS2ENVIRONMENT")
  
  if (parms.tempPath \= '') then do
  	/** remove trailing slash, if present ***/
  	if substr(parms.tempPath,length(parms.tempPath),1) = '\' then   parms.tempPath = substr(parms.tempPath,1,(length(parms.tempPath)-1))
  	rc1 = sysfiletree(parms.tempPath,resultvar,'D')	/* check if valid path */
  	if (resultvar.0 = 0) then parms.tempPath = ''		/* oops, invalid */
  end
  
  if (parms.tempPath = "") then do
  	call showErrorBox "Error", 'error1.hlp',"You must have the environment variable TEMP set to a valid directory. Press HELP for more instructions."
  	errorFlag = -99 	
  end
  /****
  if (length(parms.tempPath)>0) then do
  	if substr(parms.tempPath,length(parms.tempPath),1) \= '\' then   parms.tempPath=parms.tempPath||"\"
  end
  *****/
  
  if (value('ODBC_PATH',,'OS2ENVIRONMENT') \= '') then do
  	parms.odbcpath = translate(stripSlash(value('ODBC_PATH',,'OS2ENVIRONMENT')))
  	parms.setOdbcPath = 0
  end 
  
  signal return
  
  
  doParms:
  arg xx
  parse value xx with int '=' inv
  
  if (int = 'DEBUG') then parms.debug = inv
  if (int = 'DRIVERSLIST') then parms.dlist = inv
  if (int = 'SETUPLIST') then parms.slist = inv
  return
  
  
  SIGNAL RETURN
 
/*-----------------------------------------------------------------------------+
|                                                                              |
|  Default error handlers:                                                     |
|                                                                              |
+-----------------------------------------------------------------------------*/

SYNTAX:
  SAY 'SYNTAX ERROR:' errortext( rc ) 'in:'
  SAY sourceline( sigl )
  SIGNAL ON SYNTAX
  SIGNAL RETURN

HALT:
  SAY 'HALT occurred in:'
  SAY sourceline( sigl )
  SIGNAL ON HALT
  SIGNAL RETURN
